function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const createAdapter = (wrapInit, wrapMethod, subscribe, onMessage, init, publish, dispose, bus, options) => {
  const config = _objectSpread({}, options);

  const pool = {
    config,
    handlers: new Map(),
    disposed: false
  };
  wrapInit(pool, init, onMessage.bind(null, pool), bus);
  return Object.freeze({
    publish: wrapMethod(pool, publish),
    subscribe: wrapMethod(pool, subscribe),
    dispose: wrapMethod(pool, dispose)
  });
};

export default createAdapter;
//# sourceMappingURL=create-adapter.js.map